//+------------------------------------------------------------------+
//|                                            #_i_SpecktrAnalis.mq4 |
//|                                          Copyright  2006, klot. |
//|                                                     klot@mail.ru |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""



#import "#_lib_FFT.ex4"
void realfastfouriertransform(double& a[], int tnn, bool inversefft);
#import

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Aqua
#property indicator_color2 Gold
#property indicator_color3 Silver
#property indicator_color4 Aqua
#property indicator_color5 Magenta
#property indicator_color6 White
#property indicator_color7 Red
#property indicator_color8 Blue

#property indicator_level1 0.0
#property indicator_level2 0.1
#property indicator_level3 -0.1
#property indicator_level4 0.5
#property indicator_level5 -0.5
#property indicator_level6 0.8
#property indicator_level7 -0.8



//extern string ________nr_1________ = "";                    
string     Symb1          = "YM";	//Advanced Magn.
	


//---- buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double Buffer6[];
double Buffer7[];
double Buffer8[];

//---
extern int nr=1;
extern int n=8; //  
extern int Fmin=2;//2; //    .
extern int Fmax=128; //    .
//extern int pearson_per=5;

double aa0[];
double aa0_1[];
double aa0_2[];
double aa0_3[];
double aa0_4[];
double aa0_5[];
double aa0_6[];
double aa0_7[];


double aa1[];


int N;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexStyle(0,DRAW_HISTOGRAM,0,1);
SetIndexBuffer(0,Buffer1);
SetIndexLabel(0,"0");
SetIndexStyle(1,DRAW_LINE);
SetIndexBuffer(1,Buffer2);
SetIndexLabel(1,"1");
SetIndexStyle(2,DRAW_LINE);
SetIndexBuffer(2,Buffer3);
SetIndexLabel(2,"2");
SetIndexStyle(3,DRAW_LINE);
SetIndexBuffer(3,Buffer4);
SetIndexLabel(3,"3");
SetIndexStyle(4,DRAW_LINE);
SetIndexBuffer(4,Buffer5);
SetIndexLabel(4,"4");
SetIndexStyle(5,DRAW_LINE);
SetIndexBuffer(5,Buffer6);
SetIndexLabel(5,"5");
SetIndexStyle(6,DRAW_LINE);
SetIndexBuffer(6,Buffer7);
SetIndexLabel(6,"6");
SetIndexStyle(7,DRAW_LINE);
SetIndexBuffer(7,Buffer8);
SetIndexLabel(7,"7");



//---
   N=MathPow(2,n);
   ArrayResize(aa0,N);
   ArrayResize(aa0_1,N);
   ArrayResize(aa0_2,N);
   ArrayResize(aa0_3,N);
   ArrayResize(aa0_4,N);
   ArrayResize(aa0_5,N);
   ArrayResize(aa0_6,N);
   ArrayResize(aa0_7,N);
   

   ArrayResize(aa1,N);

if( Fmax>=N ) Fmax=N;
if( Fmin<=2 ) Fmin=2;

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   if( Bars<N) return(0);
   RefreshRates();
   //---
   for(int i=N-1; i>=0; i--) 
   { 
     aa1[i]=iClose(Symb1,0,i); 
     
     

   }
   //---
   
   InSigNormalize(aa1);
   
   
   realfastfouriertransform(aa1, N, false);

   //---
   N=ArraySize(aa1);
   //Comment("n= ",N);
   //---
   for( i=0; i<=N-1; i++) 
   { 
      if( i<Fmin || i>Fmax) 
      { 
        aa1[i]=0.0; 

      }
      aa0[i]=aa1[i];
      
      aa0_1[i]=aa1[i];
    
    
    
    
    
      
   }
   //---

   
   realfastfouriertransform(aa0, N, true);
   realfastfouriertransform(aa0_1, N, true);
   //realfastfouriertransform(aa0_2, N, true);
   //realfastfouriertransform(aa0_3, N, true);
   //realfastfouriertransform(aa0_4, N, true);
   //realfastfouriertransform(aa0_5, N, true);
   //realfastfouriertransform(aa0_6, N, true);
   //realfastfouriertransform(aa0_7, N, true);
   
   //---
   SetIndexDrawBegin(0,Bars-N);
   SetIndexDrawBegin(1,Bars-N);
   SetIndexDrawBegin(2,Bars-N);
   SetIndexDrawBegin(3,Bars-N);
   SetIndexDrawBegin(4,Bars-N);
   SetIndexDrawBegin(5,Bars-N);
   SetIndexDrawBegin(6,Bars-N);
   SetIndexDrawBegin(7,Bars-N);

   //---
   for( i=0; i<=N-1; i++)
   {
      Buffer1[i]=aa0[i];

      //Buffer2[i]=aa0_1[i];
      //Buffer3[i]=aa0_2[i];
      //Buffer4[i]=aa0_3[i];
      //Buffer5[i]=aa0_4[i];
      //Buffer6[i]=aa0_5[i];
      //Buffer7[i]=aa0_6[i];
      //Buffer8[i]=aa0_7[i];      
              
   }
   //----
   return(0);
  }
//-------------------------------------------------------------------+

void InSigNormalize(double& aa[])
{
   double sum_sqrt;
   int element_count=ArraySize(aa);
   sum_sqrt=0;
   for( int i=0; i<=element_count-1; i++)
   {
      sum_sqrt+=MathPow(aa[i],2);
   }
   sum_sqrt=MathSqrt(sum_sqrt);
   
   if (sum_sqrt!=0)
   {
      for( i=0; i<=element_count-1; i++)
      {
         aa[i]=aa[i]/sum_sqrt;
      }
   }
   return;
}

double pearson2(double X[],double Y[] ,int Bars1, int R_Period, double &R[], int ratio )
{
  
  
  int limit=Bars1-R_Period-1;
  //double X[],Y[];
  int piir,omega;
  double sumxy, sumx, sumx2, sumy, sumy2;
  double yks, kaks, kolm;
  ArrayResize(X,limit); // min size of array is using less memory
  ArrayResize(Y,limit);
  //ArrayCopySeries(X,MODE_OPEN,Pair1,0);
  //ArrayCopySeries(Y,MODE_OPEN,Pair2,0);

  omega=0;
  while(omega<=limit)
  {
    sumxy=0; 
    sumx=0; 
    sumx2=0;
    sumy=0; 
    sumy2=0;
    for(int i=1; i<=R_Period; i++)
    {
      sumxy+=X[omega+i]*Y[omega+i];
      sumx+=X[omega+i];
      sumx2+=MathPow(X[omega+i],2.); //2. is neccesary because MathPow wants both parts as double
      sumy+=Y[omega+i];
      sumy2+=MathPow(Y[omega+i],2.);//but it seems to work with "2" as well
    }  
    yks=sumxy-(sumx*sumy)/R_Period;
    kaks=sumx2-(MathPow(sumx,2.)/R_Period);
    kolm=sumy2-(MathPow(sumy,2.)/R_Period);  
    R[omega]=(yks/MathSqrt(kaks*kolm))/ratio;
    omega++;
  } 

}